//+------------------------------------------------------------------+
//|                                               ZigZag Pointer.mq4 |
//|                                    zigzag modified by Dr. Gaines |
//|                                      neamtu_victor@yahoo.com     |
//|                                         neamtu victor            |
//+------------------------------------------------------------------+
#property copyright "neamtu victor"
#property link      "neamtu_victor@yahoo.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Blue
#property indicator_width1 2
#property indicator_color2 Red
#property indicator_width2 2
//---- indicator parameters
extern double Percent=0.02;
//---- indicator buffers
double buyArrowsBuffer[];
double sellArrowsBuffer[];

bool okBuy,okSell;

   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+


int init()
  {
   IndicatorBuffers(2);
//---- drawing settings
   SetIndexStyle(0,DRAW_ARROW);
   SetIndexArrow(0, 233);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexArrow(1, 234);
//---- indicator buffers mapping
   SetIndexBuffer(0,buyArrowsBuffer);
   SetIndexBuffer(1,sellArrowsBuffer);
   SetIndexEmptyValue(0,0.0);
   
   IndicatorShortName("Percentual ZigZag("+Percent+")");
   
   Percent /= 100;   
  
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double barPrice(int shift){
   double auxPrice=0;
   
   auxPrice=(//iOpen(Symbol(),Period(),shift)+iClose(Symbol(),Period(),shift)+
   iLow(Symbol(),Period(),shift)+iHigh(Symbol(),Period(),shift))/2;
   
   return(auxPrice);
}


int start(){

   int shift;
   static double upValue,downValue;
   
   for(shift=Bars-1; shift>=0; shift--){
      
      if (shift == Bars-1){
         upValue=barPrice(Bars-1);
         downValue=barPrice(Bars-1);
         okBuy=true;
         okSell=true;
      }
      else{
         
         
         if (barPrice(shift) > upValue){ //up
            upValue=barPrice(shift);
         }
         if (barPrice(shift) < downValue){ //down
            downValue=barPrice(shift);
         }
         
         
         //Print(" barPrice: ", barPrice(shift), " value+p.. ", value );
         if (okBuy == true){
            if (barPrice(shift) > downValue + Percent*downValue){ //buy
               buyArrowsBuffer[shift]=iLow(Symbol(),Period(),shift)-10*Point;
               sellArrowsBuffer[shift]=0;
            
               downValue=downValue + Percent*downValue;
               upValue=downValue;
               
               okBuy=false;
               okSell=true;
               //Print("Bars ",Bars, " Shift ",shift," barPrice: ", value);
               
               
            }
         }
         if (okSell == true){
            if (barPrice(shift) < upValue - Percent*upValue){ //sell
               sellArrowsBuffer[shift]=iHigh(Symbol(),Period(),shift)+10*Point;
               buyArrowsBuffer[shift]=0;
            
               upValue=upValue - Percent*upValue;
               downValue=upValue;
               
               okBuy=true;
               okSell=false;
               //Print("Bars ",Bars, " Shift ",shift," barPrice: ", value);
              
            }
         }

      }
      
      
   }

   
}
  
  //end//